#include "./samc.h"
/* updated by kai, sept. 8 */

int Metropolis_ini(x,fvalue,rcost,checkInt, parms)
int *x, checkInt;
double *fvalue;
RET_COST *rcost;
PARMS *parms;
{
int *y, *e1, *e2,i,k,k1,k2,s1,s2,s1r,s2r,accept,update;
double fnew,r,un, pxy, pyx, *cor1, *cor2, sum1, sum2, ss;
RET_COST *rcosty;
int DataP=parms->DataP, TotalNcol=parms->TotalNcol, DataNum=parms->DataNum, maxvar=parms->maxvar, *bestx=parms->bestx;
double temperature=parms->temperature, *cor=parms->cor, bestvalue=parms->bestvalue;

    e1=ivector(1,DataP);
    e2=ivector(1,DataP);
    y=ivector(1,DataP);
    cor1=dvector(1,DataP);
    cor2=dvector(1,DataP);

    rcosty = cost_init(DataNum, DataP, TotalNcol);

    /* e1 is index for variable not in the current model,
       cor1 is the correponding weight, s1r is the number of variables
       e2 is the index that in hte current model
    */

     for(s1=s2=0, i=1; i<=DataP; i++){
         y[i]=x[i]; 
         if(y[i]==0){ s1++; e1[s1]=i; cor1[s1]=cor[i]; }
           else{ s2++; e2[s2]=i; cor2[s2]=cor[i]; }
        } 
     s1r=s1; s2r=s2;

     /* change here */
     /* if(s1==0){ */
    /* full model */
     
     if (s2 == maxvar){
        update=2; pxy=1.0;  /*deletion */
       }
      else if(s2<=0){ /* null model, i made changes here, assuming intercept always in */ 
           update=1;  pxy=1.0;  /* addition */
          }
       else{ 
          un=rand()*1.0/RAND_MAX;
          if(un<1.0/3) update=1;
              else if(un<2.0/3) update=2;
                else update=3;  /* exchange */
          pxy=1.0/3;
         }

     if(update==1){ 

        /* Randomly choose one from  e1 to add */
        for(sum1=0.0,i=1; i<=s1; i++) sum1+=cor1[i];
        k=1; ss=cor1[1]/sum1;
        un=rand()*1.0/RAND_MAX;
        while(un>ss && k<s1){
              k++;
              ss+=cor1[k]/sum1;
            }
        y[e1[k]]=1;
        s1r-=1; s2r+=1;
        pxy*=cor1[k]/sum1;

        sum2=1-cor1[k];
        for(i=1; i<=s2; i++) sum2+=1-cor2[i];
        pyx=(1-cor1[k])/sum2;
       }
      else if(update==2){
           /* randomly choose one from e2 to delete  */
           for(sum2=0.0,i=1; i<=s2; i++) sum2+=1-cor2[i];
           k=1; ss=(1-cor2[1])/sum2;
           un=rand()*1.0/RAND_MAX;
           while(un>ss && k<s2){
              k++;
              ss+=(1-cor2[k])/sum2;
            }
           y[e2[k]]=0;
           pxy*=(1-cor2[k])/sum2;

           s1r+=1; s2r-=1;

           sum1=cor2[k];
           for(i=1; i<=s1; i++) sum1+=cor1[i];
           pyx=cor2[k]/sum1;
          }
        else{

           for(sum1=0.0,i=1; i<=s1; i++) sum1+=cor1[i];
           k1=1; ss=cor1[1]/sum1;
           un=rand()*1.0/RAND_MAX;
           while(un>ss && k1<s1){
              k1++;
              ss+=cor1[k1]/sum1;
             }
           y[e1[k1]]=1;
           pxy*=cor1[k1]/sum1;

           for(sum2=0.0,i=1; i<=s2; i++) sum2+=1-cor2[i];
           k2=1; ss=(1-cor2[1])/sum2;
           un=rand()*1.0/RAND_MAX;
           while(un>ss && k2<s2){
              k2++;
              ss+=(1-cor2[k2])/sum2;
             }
           y[e2[k2]]=0;
           pxy*=(1-cor2[k2])/sum2;

           sum1=sum1-cor1[k1]+cor2[k2];
           sum2=sum2-(1-cor2[k2])+(1-cor1[k1]);
           pyx=cor2[k2]*(1-cor1[k1])/sum1/sum2;
         }
    
     /* need change here */
    
     cost(y, rcosty, checkInt, parms);
     fnew = rcosty->value;

     if(s1r==0) pyx*=1.0; 
     else if(s2r<=0) pyx*=1.0; /* i made a change here */
         else pyx*=1.0/3;
        
     if (rcosty->converged < 0)
       {
	 accept = 0;
       }
     else
       {
	 r=(*fvalue-fnew)/temperature+log(pyx/pxy);

         if(r>0.0) accept=1;
           else{
              un=-1.0;
              while(un<=0.0) un=rand()*1.0/RAND_MAX;
              if(un<exp(r)) accept=1;
                 else accept=0;
             }
       }


     if(accept==1){ 
        *fvalue=fnew;
        for(i=1; i<=DataP; i++) x[i]=y[i];
       }

     if(accept==1 && fnew<bestvalue){
        bestvalue=fnew;
        for(i=1; i<=DataP; i++) bestx[i]=y[i];
       }

/* Copy return structure */
if (accept == 1) {
  rcost->value = rcosty->value;
  rcost->converged = rcosty->converged;
  rcost->deviance = rcosty->deviance;
  rcost->dim = rcosty->dim;
  rcost->num_grp = rcosty->num_grp;
  copy_dvec(rcost->Yhat, rcosty->Yhat, 1, DataNum);
  copy_dvec(rcost->beta, rcosty->beta, 1, rcosty->dim);
  copy_ivec(rcost->groups, rcosty->groups, 1, rcosty->num_grp);
  copy_ivec(rcost->col_ids, rcosty->col_ids, 1, rcosty->dim);
} 

free_ivector(e1,1,DataP);
free_ivector(e2,1,DataP);
free_ivector(y,1,DataP); 
free_dvector(cor1,1,DataP);
free_dvector(cor2,1,DataP);

rcosty->num_grp = DataP;
rcosty->dim     = TotalNcol;
cost_free(rcosty, DataNum);

parms->bestvalue = bestvalue;

return 0;
}
